﻿#region "SoapBox.Core License"
/// <header module="SoapBox.Core"> 
/// Copyright (C) 2009 SoapBox Automation Inc., All Rights Reserved.
/// Contact: SoapBox Automation Licencing (license@soapboxautomation.com)
/// 
/// This file is part of SoapBox Core.
/// 
/// Commercial Usage
/// Licensees holding valid SoapBox Automation Commercial licenses may use  
/// this file in accordance with the SoapBox Automation Commercial License
/// Agreement provided with the Software or, alternatively, in accordance 
/// with the terms contained in a written agreement between you and
/// SoapBox Automation Inc.
/// 
/// GNU Lesser General Public License Usage
/// SoapBox Core is free software: you can redistribute it and/or modify 
/// it under the terms of the GNU Lesser General Public License
/// as published by the Free Software Foundation, either version 3 of the
/// License, or (at your option) any later version.
/// 
/// SoapBox Core is distributed in the hope that it will be useful, 
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU Lesser General Public License for more details.
/// 
/// You should have received a copy of the GNU Lesser General Public License 
/// along with SoapBox Core. If not, see <http://www.gnu.org/licenses/>.
/// </header>
#endregion
        
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Media.Imaging;

namespace SoapBox.Core
{
    class ConcreteMenuItem : AbstractMenuItem 
    {
        public ConcreteMenuItem()
        {
        }

        public void SetHeader(string value)
        {
            Header = value;
        }

        public void SetItems(IEnumerable<IMenuItem> value)
        {
            Items = value;
        }

        public new void SetIconFromBitmap(Bitmap value)
        {
            base.SetIconFromBitmap(value);
        }

        public void SetIsCheckable(bool value)
        {
            IsCheckable = value;
        }

        protected override void OnIsCheckedChanged()
        {
            base.OnIsCheckedChanged();
            IsCheckedChanged(this, EventArgs.Empty);
        }

        public event EventHandler IsCheckedChanged = delegate { };

        public void SetIsSeparator(bool value)
        {
            IsSeparator = value;
        }

        public void SetEnableCondition(ICondition value)
        {
            EnableCondition = value;
        }

        protected override void OnIsSubmenuOpenChanged()
        {
            base.OnIsSubmenuOpenChanged();
            IsSubmenuOpenChanged(this, EventArgs.Empty);
        }

        public event EventHandler IsSubmenuOpenChanged = delegate { };
    }
}
