#region "SoapBox.Demo License"
/// <header module="SoapBox.Demo"> 
/// Copyright (C) 2009 SoapBox Automation Inc., All Rights Reserved.
/// Contact: SoapBox Automation Licencing (license@soapboxautomation.com)
/// 
/// This file is part of SoapBox Demo.
/// 
/// GNU Lesser General Public License Usage
/// SoapBox Demo is free software: you can redistribute it and/or modify 
/// it under the terms of the GNU Lesser General Public License
/// as published by the Free Software Foundation, either version 3 of the
/// License, or (at your option) any later version.
/// 
/// SoapBox Demo is distributed in the hope that it will be useful, 
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU Lesser General Public License for more details.
/// 
/// You should have received a copy of the GNU Lesser General Public License 
/// along with SoapBox Demo. If not, see <http://www.gnu.org/licenses/>.
/// </header>
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Threading;

namespace SoapBox.Demo.PinBall
{
    public sealed class SoundManager
    {
        #region " SINGLETON DESIGN PATTERN "
        //this design pattern pulled from here: http://www.yoda.arachsys.com/csharp/singleton.html
        SoundManager()
        {
        }

        public static SoundManager Instance
        {
            get
            {
                return Nested.instance;
            }
        }
        
        class Nested
        {
            // Explicit static constructor to tell C# compiler
            // not to mark type as beforefieldinit
            static Nested()
            {
            }

            internal static readonly SoundManager instance = new SoundManager();
        }
        #endregion

        public static void PlayWav(Stream wav)
        {
            if (Properties.Settings.Default.Sound)
            {
                ThreadPool.UnsafeQueueUserWorkItem(ignoredState =>
                {
                    System.Media.SoundPlayer soundPlayer = new System.Media.SoundPlayer(wav);
                    soundPlayer.Play();
                }, null);
            }
        }
    }
}
